[Codeforces]852I - Dating

题目大意:给定一棵n个点的树,每个点上有一个汉子或妹子,每人有一个权值,每次询问一条链上选出一对权值相等的男女有多少种选法。(n,q<=10^5)

做法:比较显然的树上莫队,熟悉序列莫队那套理论再推广到树上即可,我的树上莫队好像有点假,我是先树分块,对每块的根跑一遍dfs处理到各个点的链的信息并顺便处理一个端点在这个块内的询问,常数好像有点大,卡了半天常才过……学习了一下dalao的树上莫队,求一个进和出都算一遍的dfs序,链询问转化为区间询问,在区间内但不在链上的会被计算到两次所以被抵消了,感觉很奇妙。

丑陋代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<map>
using namespace std;
char BB[1<<25],*S=BB;
inline int read()
{
    int x;char c;
    while((c=*S++)<‘0‘||c>‘9‘);
    for(x=c-‘0‘;(c=*S++)>=‘0‘&&c<=‘9‘;)x=x*10+c-‘0‘;
    return x;
}
#define MN 100000
#define K 700
struct edge{int nx,t;}e[MN*2+5];
struct query{int x,y,id;}Q[MN+5];
int a[MN+5],b[MN+5],cnt,h[MN+5],en,fa[MN+5],d[MN+5],f[MN+5],dep[MN+5];
int rt,nw,u[MN+5],A[MN+5],B[MN+5];
long long ans,C[MN+5];
bool cmp(const query&a,const query&b){return f[a.x]<f[b.x];}
map<int,int> mp;
inline void ins(int x,int y)
{
    e[++en]=(edge){h[x],y};h[x]=en;
    e[++en]=(edge){h[y],x};h[y]=en;
}
void dfs(int x)
{
    for(int i=h[x];i;i=e[i].nx)if(e[i].t!=fa[x])
    {
        fa[e[i].t]=x;dep[e[i].t]=dep[x]+1;dfs(e[i].t);
        d[x]=max(d[x],d[e[i].t]+1);
    }
    if(d[x]==K||x==rt)f[x]=x,d[x]=-1;
}
void build(int x)
{
    for(int i=h[x];i;i=e[i].nx)if(e[i].t!=fa[x])
    {
        if(!f[e[i].t])f[e[i].t]=f[x];
        build(e[i].t);
    }
}
void DFS(int x,int fa)
{
    d[x]=++cnt;
    for(int i=h[x];i;i=e[i].nx)
        if(e[i].t!=fa)DFS(e[i].t,x);
}
bool CMP(const query&a,const query&b){return d[a.y]<d[b.y];}
void cal(int x)
{
    if(u[x]^=1)ans+=a[x]?A[b[x]]:B[b[x]],a[x]?++B[b[x]]:++A[b[x]];
    else ans-=a[x]?A[b[x]]:B[b[x]],a[x]?--B[b[x]]:--A[b[x]];
}
void solve(int x,int fr)
{
    d[x]=MN+5;cal(x);
    for(;rt==f[Q[nw].x]&&Q[nw].y==x;++nw)
    {
        for(int i=Q[nw].x,u=1;i!=rt;i=fa[i])
            if(d[i]==MN+5&&u)cal(rt),u=0;else cal(i);
        C[Q[nw].id]=ans;
        for(int i=Q[nw].x,u=1;i!=rt;i=fa[i])
            if(d[i]==MN+5&&u)cal(rt),u=0;else cal(i);
    }
    for(int i=h[x];i;i=e[i].nx)
        if(e[i].t!=fr)solve(e[i].t,x);
    d[x]=0;cal(x);
}
int main()
{
    BB[fread(BB,1,1<<25,stdin)]=0;
    int n=read(),i,j,q;
    for(i=1;i<=n;++i)a[i]=read();
    for(i=1;i<=n;++i)b[i]=mp[b[i]=read()]?mp[b[i]]:mp[b[i]]=++cnt;
    for(i=1;i<n;++i)ins(read(),read());
    rt=2333333%n+1;dfs(rt);build(rt);
    for(q=read(),i=1;i<=q;++i)
    {
        Q[i].x=read();Q[i].y=read();Q[i].id=i;
        if(dep[Q[i].x]-dep[f[Q[i].x]]>dep[Q[i].y]-dep[f[Q[i].y]])swap(Q[i].x,Q[i].y);
    }
    sort(Q+1,Q+q+1,cmp);
    for(nw=1;nw<=q;)
    {
        DFS(f[Q[nw].x],cnt=0);
        for(i=nw;f[Q[i].x]==f[Q[nw].x];++i);
        sort(Q+nw,Q+i,CMP);
        solve(rt=f[Q[nw].x],ans=0);
    }
    for(i=1;i<=q;++i)printf("%I64d\n",C[i]);
}
时间: 2024-10-10 10:04:40

[Codeforces]852I - Dating的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ